$include "RapidQ.inc"
$include "gl.inc"
$include "glwgl.inc"
$include "glu.inc"
$include "glaux.inc"
$include "WIN32API.Inc"
$include "glBMP.inc"
'$include "BMP_Loader.inc"

dim MainForm as QForm
'Declare Function ChoosePixelFormat Lib "gdi32" ALIAS "ChoosePixelFormat" (ByVal hDC As Long, pfd As PIXELFORMATDESCRIPTOR) As Long
'Declare Function CreatePalette Lib "gdi32" ALIAS "CreatePalette" (pPal As LOGPALETTE) As Long
Declare Sub DeleteObject Lib "gdi32" ALIAS "DeleteObject" (hObject As Long)
Declare Sub DescribePixelFormat Lib "gdi32" ALIAS "DescribePixelFormat" (ByVal hDC As Long, ByVal PixelFormat As Long, ByVal nBytes As Long, pfd As PIXELFORMATDESCRIPTOR)
'Declare Function GetDC Lib "gdi32" ALIAS "GetDC" (ByVal hWnd As Long) As Long
'Declare Function GetPixelFormat Lib "gdi32" ALIAS "GetPixelFormat" (ByVal hDC As Long) As Long
Declare Sub GetSystemPaletteEntries Lib "gdi32" ALIAS "GetSystemPaletteEntries" (ByVal hDC As Long, ByVal start As Long, ByVal entries As Long, ByVal ptrEntries As Long)
Declare Sub RealizePalette Lib "gdi32" ALIAS "RealizePalette" (ByVal hPalette As Long)
Declare Sub SelectPalette Lib "gdi32" ALIAS "SelectPalette" (ByVal hDC As Long, ByVal hPalette As Long, ByVal bln As Long)
'Declare Function SetPixelFormat Lib "gdi32" ALIAS "SetPixelFormat" (ByVal hDC As Long, ByVal i As Long, pfd As PIXELFORMATDESCRIPTOR) As integer
Declare Sub SwapBuffers Lib "gdi32" ALIAS "SwapBuffers" (ByVal hDC As Long)
'Declare Function wglCreateContext Lib "OpenGL32" ALIAS "wglCreateContext_" (ByVal hDC As Long) As Long
Declare Sub wglDeleteContext Lib "OpenGL32" ALIAS "wglDeleteContext" (ByVal hContext As Long)
Declare Sub wglMakeCurrent Lib "OpenGL32" ALIAS "wglMakeCurrent" (ByVal l1 As Long, ByVal l2 As Long)


Dim GHDC As Long
Dim GLDC As Long
Dim EXTS As Long

Public Sub glStart(bpp As Single, zbuffer As Integer, stencil As Integer, hdc As Long)
    Dim pf As PIXELFORMATDESCRIPTOR
    Dim npf As Long
    
    pf.nSize = Len(pf)
    pf.nVersion = 1
    pf.dwFlags = PFD_DRAW_TO_WINDOW Or PFD_SUPPORT_OPENGL Or PFD_DOUBLEBUFFER
    pf.iPixelType = PFD_TYPE_RGBA
    pf.cColorBits = bpp
    pf.cDepthBits = zbuffer
    pf.cStencilBits = stencil
    pf.iLayerType = PFD_MAIN_PLANE
    
    npf = ChoosePixelFormat(hdc, pf)
    SetPixelFormat hdc, npf, pf
    
    GHDC = hdc
    GLDC = wglCreateContext(hdc)
    wglMakeCurrent GHDC, GLDC
    
    EXTS = extSetupExts()
End Sub

Public Sub glQuit()
    wglMakeCurrent 0, 0
    wglDeleteContext GLDC
End Sub

Public Sub glFlip()
    SwapBuffers GHDC
End Sub


DIM Texture AS QBITMAP

Type EGLTEXTUREDATA
    Height As Long
    Width As Long
    bpp As Integer
    imgSizes As Long
    tdata() As Byte
End Type

'Public Const DETAIL_SPHERE = 50

Dim glTexture as EGLTEXTUREDATA
glTexture.Height = 256
glTexture.Width = 256
glTexture.bpp = 24
glTexture.imgSizes = 256
glTexture.tData(0) = 256

'Dim Text


Public Function auxTexture(texture As EGLTEXTUREDATA) As Long
    Dim tID As Long
    
    glGenTextures 1, tID
    glBindTexture TARGET_TEXTURE_2D, tID
    
    glTexParameteri TARGET_TEXTURE_2D, TEXTURE_MAG_FILTER, FILTER_NEAREST
    glTexParameteri TARGET_TEXTURE_2D, TEXTURE_MIN_FILTER, FILTER_NEAREST
    
    glTexImage2D TARGET_TEXTURE_2D, 0, PIXEL_RGB, texture.Width, texture.Height, 0, PIXEL_RGB, PT_UNSIGNED_BYTE, texture.tdata(0)
    auxTexture = tID
End Function


'Main Code
Declare Sub Init()
Declare Sub Display()


Dim hDc as long
'Hdc = GetDC(MainForm.Handle)
'glStart(16, 16, 0, hDC)
'glClearColor(0, 0, 0, 0)
'glClear(GL_COLOR_BIT)
'glFlip()

dim tics as integer
tics=0

Dim FPS as Integer
Dim FrameTime as Integer
Dim Frames as Integer
Dim seconds0 as Double
Dim delta_tics as Integer
Dim Delta_Seconds as Double

Dim glTimer as QDXTimer

SUB GetElapsedTime()
   Seconds = Seconds + 1
'   MainForm.Caption = "OpenGL Engine - " + STR$(FrameTime/(Seconds)) + " FPS - " + STR$(Seconds/10) + " Seconds"
'   FrameTime = tics/(seconds/10)
    FrameTime = glTimer.framerate
END SUB


SUB TimerOver

  IF tics < 2 THEN Init()
   Display()
   MainForm.Caption = STR$(FrameTime)
End SUB

glTimer.Interval = 1
glTimer.Enabled = 1
glTimer.OnTimer = TimerOver 

Dim SecondsTimer as QTimer
SecondsTimer.Interval = 100
SecondsTimer.Enabled = 1
SecondsTimer.OnTimer = GetElapsedTime


SUB Init()
    Hdc = GetDC(MainForm.Handle)
    glStart(16, 16, 0, HDC)
    
        glEnable(GL_TEXTURE_2D)
    glDisable(GL_DEPTH_TEST)

    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE)    
    
    '  glTexture =  auxTexture(glTexture)
     glMatrixMode(GL_PROJECTION)
     glLoadIdentity
'     gluPerspective(50,1024/768,0.1,50)
'     glTranslatef(-1.0, -1.0, 0.0)    

'     LoadTexture("D:\Marc\Programming\Basic\rqbeta\duran_h.tga")
     LoadTexture("gl.tga")     
    
      'LoadImage "duran_h.tga"
End Sub


Dim rot_y as integer

SUB Display()

  glClear GL_COLOR_BUFFER_BIT
'  glClear  GL_TEXTURE_BIT
    
 glPushMatrix
   glRotatef(rot_y, 0.0, 0.0, 1.0)
   glTranslatef(-0.5,-0.5,0.5)

'glBindTexture GL_TEXTURE_2D, GetTexID(0)
'glBindTexture GL_TEXTURE_2D, GetTexID(0)

     glBegin(GL_QUADS)
'         glColor3f(120/256, 120/256, 220/256)
            glTexCoord2i(0, 0)
            glVertex3f(0, 0, 0)
             
'        glColor3f(220/256, 120/256, 220/256)
           glTexCoord2i(0, 1)
          glVertex3f(0, 1.0, 0.0)
             
'       glColor3f(120/256, 220/256, 220/256)            
            glTexCoord2i(1,1)
          glVertex3f(1.0, 1.0, 0.0)
             
'      glColor3f(120/256, 220/256, 20/256)
              glTexCoord2i(1, 0)
              glVertex3f(1.0, 0, 0.0)
     glEnd
glPopMatrix

'ot_y = rot_y +1

glFlip()
tics = tics + 1

END SUB

MainForm.Caption = "OpenGL Engine"
MainForm.Width = 640
MainForm.Height = 480
MainForm.BorderStyle = 6
MainForm.Center
MainForm.ShowModal
